      INCLUDE 'FLIB.FI'


      PROGRAM FLOWCALC

      INCLUDE 'FLIB.FD'

      DIMENSION TOTMLNEW(50),TOTMLOLD(50),NCOUNTER(50)

      COMMON/GROUPA/GNFD(50,20),NS,NF,NE,NW
      COMMON/GROUPB/COMP(14)
      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      INTEGER*2 dummy

      CHARACTER COMP*40,FLDATA*28,FLRSLT*28

      dummy=ABOUTBOXQQ('          Flowsheeting Calculations Program\rC.P
     *.PAPAGEORGIOU - Middlesex University 2005'C) 

90    FORMAT(A)
93    FORMAT(/1X,'Reading data. Please wait. . . .')
94    FORMAT(/1X,'Performing calculations. Please wait. . .')
95    FORMAT(/1X,'Performing calculations for unit No:  ',I3)
96    FORMAT(/1X,'Maximum number of convergence iterations [1-10000]:'\)
97    FORMAT(/1X,'Accepted convergence tolerence   [0.005 - 0.00005]:'\)
98    FORMAT(/1X,'EXIT - END OF CALCULATIONS')
99    FORMAT(/1X,'Rcycling stream from unit No:',I3,' To Unit No:',I3
     */1X,'Does not converge after',I7,' iterations')
100   FORMAT(2I14)
200   FORMAT(5F14.2)
300   FORMAT(3I14)
400   FORMAT(I20)
500   FORMAT(F20.0)
600   FORMAT('             0             0             0')

      OPEN(3,FILE='USER',TITLE='Information About Calculations',
     *IOFOCUS=.TRUE.,BLOCKSIZE=240000) 
      OPEN(9,FILE='USER',TITLE='Recycling Convergence Accuracy',
     *IOFOCUS=.TRUE.,BLOCKSIZE=2400)
      DO 999 I=1,50
      DO 999 J=1,20
999   GNFD(I,J)=0.0
      FLDATA='DatFile.tmp'
      OPEN(1,FILE=FLDATA,STATUS='OLD',ACCESS='SEQUENTIAL')
      FLRSLT='ResFile.tmp'
      OPEN(2,FILE=FLRSLT,STATUS='NEW',ACCESS='SEQUENTIAL')
      WRITE(3,93)
      CALL DATAINPUT
      CLOSE(1,STATUS='KEEP')
      WRITE(3,94)
      KN=0
      NR=1
3     WRITE(3,95)NR
      CALL STREAMARR
      DO 4 J=1,NR
      DO 4 I=NW+1,NW+NO
4     IF(GNFD(I,2).EQ.EQPM(J,1))GO TO 5
      GO TO 7
5     KN=KN+1
      IF(KN.GT.1)GO TO 53
51    WRITE(9,96)
      READ(9,400,ERR=51)NCMAX
      IF(NCMAX.LT.1.OR.NCMAX.GT.10000)GO TO 51
52    WRITE(9,97)
      READ(9,500,ERR=52)EMIN
      IF(EMIN.GT.0.005.OR.EMIN.LT.0.00005)GO TO 52
53    TOTMLNEW(I)=0.0
      NCOUNTER(I)=NCOUNTER(I)+1
      DO 6 K=7,NL
6     TOTMLNEW(I)=TOTMLNEW(I)+GNFD(I,K)
      IF(TOTMLNEW(I).EQ.0.0)GO TO 61
      IF(ABS((TOTMLNEW(I)-TOTMLOLD(I))/TOTMLNEW(I)).LT.EMIN)GO TO 7
      GO TO 62
61    IF(ABS(TOTMLNEW(I)-TOTMLOLD(I)).LT.0.005)GO TO 7
62    IF(NCOUNTER(I).EQ.NCMAX)GO TO 15
      NR=J
      TOTMLOLD(I)=TOTMLNEW(I)
      GO TO 3
7     IF(NR.EQ.NE)GO TO 8
      NR=NR+1
      GO TO 3
8     NS=NF
      DO 13 NR=1,NE
      NO=0
      DO 9 I=4,8
9     IF(EQPM(NR,I).NE.0.0)NO=NO+1
      WRITE(2,100)NR,NO
      DO 11 I=1,NO
      DO 10 J=1,NL
10    PROD(I,J)=GNFD(I+NS,J)
      PROD(I,5)=PROD(I,5)/1000.0
      PROD(I,6)=PROD(I,6)/1000.0
11    WRITE(2,200)(PROD(I,J),J=1,NL)
      DO 12 I=1,NO
      DO 12 J=1,NL
12    PROD(I,J)=0.0
      NS=NS+NO
13    CONTINUE
      DO 14 I=1,50
      NFR=GNFD(I,1)
      NTO=GNFD(I,2)
      IF(NCOUNTER(I).NE.0)WRITE(2,300)NFR,NTO,NCOUNTER(I)
14    CONTINUE
      GO TO 16
15    WRITE(3,99)NR,J,NCMAX
      CALL PROGSTOP   
16    WRITE(2,600)
      CLOSE(2,STATUS='KEEP')
      WRITE(3,98)
      STOP
      END


      SUBROUTINE PROGSTOP

      INCLUDE 'FLIB.FD'

      INTEGER*2 dummy1

      CLOSE(2,STATUS='DELETE')      
      dummy1=MESSAGEBOXQQ('Calculations were interrupted!'C,'Error Messa
     *ge'C,MB$ICONSTOP)
      STOP
      END


      SUBROUTINE DATAINPUT

      COMMON/GROUPA/GNFD(50,20),NS,NF,NE,NW
      COMMON/GROUPB/COMP(14)
      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      CHARACTER COMP*40,TITLE*80

100   FORMAT(A)
200   FORMAT(4I14)
300   FORMAT(5F14.0)
400   FORMAT(3F14.0)
500   FORMAT(2I14)
600   FORMAT(5F14.2)
700   FORMAT(A)
800   FORMAT(F14.3)

      READ(1,100)TITLE
      READ(1,200)NC,NP,NF,NE
      READ(1,100)(COMP(I),I=1,NC)
      DO 1 I=1,NC
      READ(1,300)(PHPR(I,J),J=1,NP)
      PHPR(I,13)=1000.0*PHPR(I,13)
      PHPR(I,14)=1000.0*PHPR(I,14)
      PHPR(I,15)=1000.0*PHPR(I,15)
1     PHPR(I,17)=1000.0*PHPR(I,17)
      NL=NC+6
      DO 2 I=1,NF
      READ(1,300)(GNFD(I,J),J=1,NL)
      GNFD(I,5)=1000.0*GNFD(I,5)
2     GNFD(I,6)=1000.0*GNFD(I,6)
      WRITE(2,100)TITLE
      WRITE(2,500)NE,NL
	DO 3 I=1,NC
      WRITE(2,700)COMP(I)
3	WRITE(2,800)PHPR(I,1)
      NR=0
      WRITE(2,500)NR,NF
      DO 5 I=1,NF
      DO 4 J=1,NL
4     PROD(I,J)=GNFD(I,J)
      PROD(I,5)=PROD(I,5)/1000.0
      PROD(I,6)=PROD(I,6)/1000.0
5     WRITE(2,600)(PROD(I,J),J=1,NL)
      DO 6 I=1,NF
      DO 6 J=1,NL
6     PROD(I,J)=0.0
      NS=NF
      DO 7 I=1,NE
      READ(1,400)(EQPM(I,J),J=1,3)
      NM=EQPM(I,3)
      READ(1,300)(EQPM(I,J),J=4,NM)
7     CONTINUE
      RETURN
      END


      SUBROUTINE STREAMARR

      COMMON/GROUPA/GNFD(50,20),NS,NF,NE,NW
      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      NI=0
      DO 2 I=1,NS
      IF(GNFD(I,2).NE.EQPM(NR,1))GO TO 2
      NI=NI+1
      DO 1 J=1,NL
1     FEED(NI,J)=GNFD(I,J)
2     CONTINUE
      NO=0
      DO 3 I=4,8
3     IF(EQPM(NR,I).NE.0.0)NO=NO+1
      NT=EQPM(NR,2)
      CALL CALLUNIT(NT)
      DO 4 I=1,50
4     IF(GNFD(I,1).EQ.EQPM(NR,1).OR.GNFD(I,1).EQ.0.0)GO TO 5
5     NW=I-1
      DO 6 I=1,NO
      DO 6 J=1,NL
6     GNFD(I+NW,J)=PROD(I,J)
      DO 7 I=1,NI
      DO 7 J=1,NL
7     FEED(I,J)=0.0
      DO 8 I=1,NO
      DO 8 J=1,NL
8     PROD(I,J)=0.0
      IF(NS.EQ.NW)NS=NS+NO
      RETURN
      END


      SUBROUTINE CALLUNIT(N)

      GO TO(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22)N      
1     CALL UNIT01
      RETURN
2     CALL UNIT02
      RETURN
3     CALL UNIT03
      RETURN
4     CALL UNIT04
      RETURN
5     CALL UNIT05
      RETURN
6     CALL UNIT06
      RETURN
7     CALL UNIT07
      RETURN
8     CALL UNIT08
      RETURN
9     CALL UNIT09
      RETURN
10    CALL UNIT10
      RETURN
11    CALL UNIT11
      RETURN
12    CALL UNIT12
      RETURN
13    CALL UNIT13
      RETURN
14    CALL UNIT14
      RETURN
15    CALL UNIT15
      RETURN
16    CALL UNIT16
      RETURN
17    CALL UNIT17
      RETURN
18    CALL UNIT18
      RETURN
19    CALL UNIT19
      RETURN
20    CALL UNIT20
      RETURN
21    CALL UNIT21
      RETURN
22    CALL UNIT22
      RETURN
      END


      SUBROUTINE CALCENTH(COMPENTH,I,J)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Insufficient data for enthalpy calculation'
     */1X,'of output stream(s) from unit No:',I3)

      IF(PROD(I,J).EQ.0.0)GO TO 4
      IF(PROD(I,4).LT.PHPR(J-6,2))GO TO 2
      IF(PROD(I,4).EQ.PHPR(J-6,2).AND.PROD(I,3).EQ.1.0)GO TO 2
      IF(PROD(I,4).EQ.PHPR(J-6,2).AND.PROD(I,3).EQ.2.0)GO TO 1
      IF(PROD(I,4).GT.PHPR(J-6,2).AND.PROD(I,4).LT.PHPR(J-6,3))GO TO 1
      IF(PROD(I,4).EQ.PHPR(J-6,3).AND.PROD(I,3).EQ.2.0)GO TO 1
      IF(PROD(I,4).EQ.PHPR(J-6,3).AND.PROD(I,3).EQ.3.0)GO TO 3
      IF(PROD(I,4).GT.PHPR(J-6,3))GO TO 3
      WRITE(3,100)NR
      CALL PROGSTOP
1     CALL ENTHLIQ(COMPENTH,I,J)
      RETURN
2     CALL ENTHSOL(COMPENTH,I,J)
      RETURN
3     CALL ENTHGAS(COMPENTH,I,J)
      RETURN
4     COMPENTH=0.0
      RETURN
      END


      SUBROUTINE ENTHLIQ(COMPENTH,I,J)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      IF(PHPR(J-6,2).GE.298.0)GO TO 11
      IF(PHPR(J-6,3).LE.298.0)GO TO 12
      F1=PHPR(J-6,8)*(PROD(I,4)-298.0)
      F2=PHPR(J-6,9)*(PROD(I,4)**2-298.0**2)/2.0
      COMPENTH=PROD(I,J)*(F1+F2)
      RETURN
11    F1=PHPR(J-6,10)*(PHPR(J-6,2)-298.0)
      F2=PHPR(J-6,11)*(PHPR(J-6,2)**2-298.0**2)/2.0
      F3=PHPR(J-6,12)*(PHPR(J-6,2)**3-298.0**3)/3.0
      F4=PHPR(J-6,13)
      F5=PHPR(J-6,8)*(PROD(I,4)-PHPR(J-6,2))
      F6=PHPR(J-6,9)*(PROD(I,4)**2-PHPR(J-6,2)**2)/2.0
      COMPENTH=PROD(I,J)*(F1+F2+F3+F4+F5+F6)
      RETURN
12    F1=PHPR(J-6,8)*(PROD(I,4)-PHPR(J-6,3))
      F2=PHPR(J-6,9)*(PROD(I,4)**2-PHPR(J-6,3)**2)/2.0
      F3=PHPR(J-6,14)
      F4=PHPR(J-6,4)*(PHPR(J-6,3)-298.0)
      F5=PHPR(J-6,5)*(PHPR(J-6,3)**2-298.0**2)/2.0
      F6=PHPR(J-6,6)*(PHPR(J-6,3)**3-298.0**3)/3.0
      F7=PHPR(J-6,7)*(PHPR(J-6,3)**4-298.0**4)/4.0
      COMPENTH=PROD(I,J)*(F1+F2-F3+F4+F5+F6+F7)
      RETURN
      END

      SUBROUTINE ENTHSOL(COMPENTH,I,J)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      IF(PHPR(J-6,2).GE.298.0)GO TO 21
      IF(PHPR(J-6,3).LE.298.0)GO TO 22
      F1=PHPR(J-6,8)*(PHPR(J-6,2)-298.0)
      F2=PHPR(J-6,9)*(PHPR(J-6,2)**2-298.0**2)/2.0
      F3=PHPR(J-6,13)
      F4=PHPR(J-6,10)*(PROD(I,4)-PHPR(J-6,2))
      F5=PHPR(J-6,11)*(PROD(I,4)**2-PHPR(J-6,2)**2)/2.0
      F6=PHPR(J-6,12)*(PROD(I,4)**3-PHPR(J-6,2)**3)/3.0
      COMPENTH=PROD(I,J)*(F1+F2-F3+F4+F5+F6)
      RETURN
21    F1=PHPR(J-6,10)*(PROD(I,4)-298.0)
      F2=PHPR(J-6,11)*(PROD(I,4)**2-298.0**2)/2.0
      F3=PHPR(J-6,12)*(PROD(I,4)**3-298.0**3)/3.0
      COMPENTH=PROD(I,J)*(F1+F2+F3)
      RETURN
22    F1=PHPR(J-6,4)*(PHPR(J-6,3)-298.0)
      F2=PHPR(J-6,5)*(PHPR(J-6,3)**2-298.0**2)/2.0
      F3=PHPR(J-6,6)*(PHPR(J-6,3)**3-298.0**3)/3.0
      F4=PHPR(J-6,7)*(PHPR(J-6,3)**4-298.0**4)/4.0
      F5=PHPR(J-6,14)
      F6=PHPR(J-6,8)*(PHPR(J-6,2)-PHPR(J-6,3))
      F7=PHPR(J-6,9)*(PHPR(J-6,2)**2-PHPR(J-6,3)**2)/2.0
      F8=PHPR(J-6,13)
      F9=PHPR(J-6,10)*(PROD(I,4)-PHPR(J-6,2))
      F10=PHPR(J-6,11)*(PROD(I,4)**2-PHPR(J-6,2)**2)/2.0
      F11=PHPR(J-6,12)*(PROD(I,4)**3-PHPR(J-6,2)**3)/3.0
      COMPENTH=PROD(I,J)*(F1+F2+F3+F4-F5+F6+F7-F8+F9+F10+F11)
      RETURN
      END


      SUBROUTINE ENTHGAS(COMPENTH,I,J)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      IF(PHPR(J-6,2).GE.298.0)GO TO 31
      IF(PHPR(J-6,3).LE.298.0)GO TO 32
      F1=PHPR(J-6,4)*(PROD(I,4)-PHPR(J-6,3))
      F2=PHPR(J-6,5)*(PROD(I,4)**2-PHPR(J-6,3)**2)/2.0
      F3=PHPR(J-6,6)*(PROD(I,4)**3-PHPR(J-6,3)**3)/3.0
      F4=PHPR(J-6,7)*(PROD(I,4)**4-PHPR(J-6,3)**4)/4.0
      F5=PHPR(J-6,14)
      F6=PHPR(J-6,8)*(PHPR(J-6,3)-298.0)
      F7=PHPR(J-6,9)*(PHPR(J-6,3)**2-298.0**2)/2.0
      COMPENTH=PROD(I,J)*(F1+F2+F3+F4+F5+F6+F7)
      RETURN
31    F1=PHPR(J-6,4)*(PROD(I,4)-PHPR(J-6,3))
      F2=PHPR(J-6,5)*(PROD(I,4)**2-PHPR(J-6,3)**2)/2.0
      F3=PHPR(J-6,6)*(PROD(I,4)**3-PHPR(J-6,3)**3)/3.0
      F4=PHPR(J-6,7)*(PROD(I,4)**4-PHPR(J-6,3)**4)/4.0
      F5=PHPR(J-6,14)
      F6=PHPR(J-6,8)*(PHPR(J-6,3)-PHPR(J-6,2))
      F7=PHPR(J-6,9)*(PHPR(J-6,3)**2-PHPR(J-6,2)**2)/2.0
      F8=PHPR(J-6,13)
      F9=PHPR(J-6,10)*(PHPR(J-6,2)-298.0)
      F10=PHPR(J-6,11)*(PHPR(J-6,2)**2-298.0**2)/2.0
      F11=PHPR(J-6,12)*(PHPR(J-6,2)**3-298.0**3)/3.0
      COMPENTH=PROD(I,J)*(F1+F2+F3+F4+F5+F6+F7+F8+F9+F10+F11)
      RETURN
32    F1=PHPR(J-6,4)*(PROD(I,4)-298.0)
      F2=PHPR(J-6,5)*(PROD(I,4)**2-298.0**2)/2.0
      F3=PHPR(J-6,6)*(PROD(I,4)**3-298.0**3)/3.0
      F4=PHPR(J-6,7)*(PROD(I,4)**4-298.0**4)/4.0
      COMPENTH=PROD(I,J)*(F1+F2+F3+F4)
      RETURN
      END

      
      SUBROUTINE CALCVLE

      DIMENSION PVAP(2)
      
      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

100   FORMAT(/1X,'Inaccurate data for vapour/liquid'
     */1X,'equilibrium calculations of unit No:',I3)

      DO 998 J=7,NL
998   FEED(L,J)=PHPR(J-6,1)*FEED(L,J)/PHPR(J-6,21)
      IF(NMI.EQ.0.AND.NIM.EQ.0.AND.NNC.EQ.0)GO TO 1 
      IF(NMI.NE.0.AND.NIM.EQ.0.AND.NNC.EQ.0)GO TO 10
      IF(NMI.EQ.0.AND.NIM.NE.0.AND.NNC.EQ.0)GO TO 20
      IF(NMI.EQ.0.AND.NIM.EQ.0.AND.NNC.NE.0)GO TO 30
      IF(NMI.NE.0.AND.NIM.NE.0.AND.NNC.EQ.0)GO TO 40
      IF(NMI.NE.0.AND.NIM.EQ.0.AND.NNC.NE.0)GO TO 50
      IF(NMI.EQ.0.AND.NIM.NE.0.AND.NNC.NE.0)GO TO 60
      IF(NMI.NE.0.AND.NIM.NE.0.AND.NNC.NE.0)GO TO 70
1     DO 2 J=7,NL
2     PROD(1,J)=0.0
      GO TO 90
10    IF(NMI.LT.2)GO TO 80
      PPMI=PROD(1,5)
      CALL VLEMI(PPMI)
      GO TO 90
20    IF(NIM.GT.2)GO TO 80
      PPIM=PROD(1,5)
      CALL VLEIM(PPIM)
      GO TO 90
30    DO 31 K=1,NNC
      J=NC(K)+6
31    PROD(1,J)=FEED(L,J)
      GO TO 90
40    IF(NMI.LT.2.OR.NIM.GT.1)GO TO 80
      PPMM=PROD(1,5)
      CALL VLEMM(PPMM)
      GO TO 90
50    IF(NMI.LT.2)GO TO 80
      GTNC=0.0
      FTMI=0.0
      DO 511 K=1,NNC
      J=NC(K)+6
      PROD(1,J)=FEED(L,J)
511   GTNC=GTNC+PROD(1,J)
      IF(GTNC.EQ.0.0)GO TO 10
      DO 512 K=1,NMI
      J=MI(K)+6
512   FTMI=FTMI+FEED(L,J) 
      IF(FTMI.EQ.0.0)GO TO 30
      PPMIMAX=PROD(1,5)
      PPMIMIN=0.0
52    PPMI=(PPMIMAX+PPMIMIN)/2.0
      PPNC=PROD(1,5)-PPMI
      GTMI=0.0
      CALL VLEMI(PPMI)
      DO 53 K=1,NMI
      J=MI(K)+6
53    GTMI=GTMI+PROD(1,J) 
      GTMIC=PPMI*GTNC/PPNC
      IF(GTMI.EQ.0.0)GO TO 54
      IF(ABS((GTMIC-GTMI)/GTMI).LT.0.00005)GO TO 90
      GO TO 55
54    IF(ABS(GTMI-GTMIC).LT.0.005)GO TO 90
55    IF(GTMI.GT.GTMIC)PPMIMIN=PPMI
      IF(GTMI.LT.GTMIC)PPMIMAX=PPMI
      IF((PPMIMAX-PPMIMIN).LT.0.1)GO TO 90
      GO TO 52  
60    IF(NIM.GT.2)GO TO 80
      GTNC=0.0
      FTIM=0.0
      DO 611 K=1,NNC
      J=NC(K)+6
      PROD(1,J)=FEED(L,J)
611   GTNC=GTNC+PROD(1,J)  
      IF(GTNC.EQ.0.0)GO TO 20
      DO 612 K=1,NIM
      J=IM(K)+6
612   FTIM=FTIM+FEED(L,J) 
      IF(FTIM.EQ.0.0)GO TO 30
      PPIM=0.0
      DO 62 K=1,NIM
      J=IM(K)+6
      PVAP(K)=133.32*EXP(PHPR(J-6,18)-PHPR(J-6,19)/
     *(PROD(1,4)+PHPR(J-6,20)))
62    PPIM=PPIM+PVAP(K)
      PPNC=PROD(1,5)-PPIM
      IF(PPIM.LT.PROD(1,5))GO TO 64
      J=IM(1)+6
      IF(PPIM.GE.PROD(1,5).AND.NIM.EQ.1)PROD(1,J)=FEED(L,J)
      IF(PPIM.GE.PROD(1,5).AND.NIM.EQ.2)GO TO 63
      GO TO 90
63    IF(PVAP(1).GE.PROD(1,5).AND.PVAP(2).GE.PROD(1,5))GO TO 69
      IF(PVAP(1).GE.PROD(1,5).AND.PVAP(2).LT.PROD(1,5))GO TO 68
      IF(PVAP(1).LT.PROD(1,5).AND.PVAP(2).GE.PROD(1,5))GO TO 67
      IF(PPIM.GE.PROD(1,5).AND.PVAP(1).GT.PVAP(2))GO TO 68
      IF(PPIM.GE.PROD(1,5).AND.PVAP(2).GT.PVAP(1))GO TO 67
64    KV=0
      DO 65 K=1,NIM
      J=IM(K)+6 
      PROD(1,J)=PVAP(K)*GTNC/PPNC
      IF(PROD(1,J).GT.FEED(L,J).AND.NIM.EQ.1)PROD(1,J)=FEED(L,J)
65    IF(PROD(1,J).GT.FEED(L,J).AND.NIM.EQ.2)KV=1
      IF(KV.EQ.1)GO TO 66
      GO TO 90
66    J1=IM(1)+6 
      J2=IM(2)+6 
      IF(PROD(1,J1).GE.FEED(L,J1).AND.PROD(1,J2).GE.FEED(L,J2))GO TO 69
      IF(PROD(1,J1).GE.FEED(L,J1).AND.PROD(1,J2).LT.FEED(L,J2))GO TO 68
67    PROD(1,J2)=FEED(L,J2)
      GTNC=GTNC+PROD(1,J2)
      PPNC=PPNC+PVAP(2)
      PROD(1,J1)=PVAP(1)*GTNC/PPNC
      IF(PROD(1,J1).GE.FEED(L,J1))PROD(1,J1)=FEED(L,J1)
      GO TO 90
68    PROD(1,J1)=FEED(L,J1)
      GTNC=GTNC+PROD(1,J1)
      PPNC=PPNC+PVAP(1)
      PROD(1,J2)=PVAP(2)*GTNC/PPNC
      IF(PROD(1,J2).GE.FEED(L,J2))PROD(1,J2)=FEED(L,J2)
      GO TO 90
69    PROD(1,J1)=FEED(L,J1)
      PROD(1,J2)=FEED(L,J2)
      GO TO 90
70    IF(NMI.LT.2.OR.NIM.GT.1)GO TO 80
      GTNC=0.0
      FTMI=0.0
      DO 71 K=1,NNC
      J=NC(K)+6
      PROD(1,J)=FEED(L,J)
71    GTNC=GTNC+PROD(1,J)  
      IF(GTNC.EQ.0.0)GO TO 40
      DO 72 K=1,NMI
      J=MI(K)+6
72    FTMI=FTMI+FEED(L,J) 
      IF(FTMI.EQ.0.0)GO TO 60
      J1=IM(1)+6
      IF(FEED(L,J1).EQ.0.0)GO TO 50
      PPIM=133.32*EXP(PHPR(J1-6,18)-PHPR(J1-6,19)/
     *(PROD(1,4)+PHPR(J1-6,20)))
      IF(PPIM.GE.PROD(1,5))GO TO 73
      PROD(1,J1)=PPIM*GTNC/PPNC
      IF(PROD(1,J1).GT.FEED(L,J1))GO TO 73
      GO TO 74
73    PROD(1,J1)=FEED(L,J1)
      GTNC=GTNC+PROD(1,J1)
      PPIM=0.0
74    PPMIMAX=PROD(1,5)-PPIM
      PPMIMIN=0.0
75    PPMI=(PPMIMAX+PPMIMIN)/2.0
      PPNC=PROD(1,5)-PPMI-PPIM
      GTMI=0.0      
      CALL VLEMI(PPMI)
      DO 76 K=1,NMI
      J=MI(K)+6
76    GTMI=GTMI+PROD(1,J) 
      GTMIC=PPMI*GTNC/PPNC
      IF(GTMI.EQ.0.0)GO TO 77
      IF(ABS((GTMI-GTMIC)/GTMI).LT.0.00005)GO TO 90
      GO TO 78
77    IF(ABS(GTMIC-GTMI).LT.0.005)GO TO 90
78    IF(GTMI.GT.GTMIC)PPMIMIN=PPMI
      IF(GTMI.LT.GTMIC)PPMIMAX=PPMI
      IF((PPMIMAX-PPMIMIN).LT.0.1)GO TO 90
      GO TO 75
80    WRITE(3,100)NR
      CALL PROGSTOP
90    DO 99 J=7,NL
99    PROD(2,J)=FEED(L,J)-PROD(1,J)
      DO 999 J=7,NL
      FEED(L,J)=PHPR(J-6,21)*FEED(L,J)/PHPR(J-6,1)
      PROD(1,J)=PHPR(J-6,21)*PROD(1,J)/PHPR(J-6,1)
999   PROD(2,J)=PHPR(J-6,21)*PROD(2,J)/PHPR(J-6,1)
      RETURN
      END


      SUBROUTINE VLEMI(PPMI)

      DIMENSION PVAP(14) 

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

      BF=0.0
      DF=0.0
      FTMI=0.0
      DO 1 K=1,NMI
      J=MI(K)+6
      PVAP(K)=133.32*EXP(PHPR(J-6,18)-PHPR(J-6,19)/
     *(PROD(1,4)+PHPR(J-6,20)))
1     FTMI=FTMI+FEED(L,J) 
      IF(FTMI.EQ.0.0)GO TO 12
      DO 11 K=1,NMI
      J=MI(K)+6
      BF=BF+(FEED(L,J)/FTMI)*(PVAP(K)/PPMI)
11    DF=DF+(FEED(L,J)/FTMI)/(PVAP(K)/PPMI)
      IF(BF.GT.1.0.AND.DF.GT.1.0)GO TO 16
      IF(BF.LT.1.0)GO TO 12
      IF(BF.EQ.1.0.AND.LID.EQ.0)GO TO 12
      IF(BF.EQ.1.0.AND.LID.EQ.1)GO TO 16
      IF(DF.LT.1.0)GO TO 14
      IF(DF.EQ.1.0.AND.LID.EQ.0)GO TO 16
      IF(DF.EQ.1.0.AND.LID.EQ.1)GO TO 14
12    DO 13 K=1,NMI
      J=MI(K)+6
13    PROD(1,J)=0.0
      RETURN
14    DO 15 K=1,NMI
      J=MI(K)+6
15    PROD(1,J)=FEED(L,J)
      RETURN
16    GMAX=FTMI
      GMIN=0.0
2     GOLD=(GMAX+GMIN)/2.0 
      IF((GMAX-GMIN).LT.0.01)GO TO 6
      GNEW=0.0
      DO 3 K=1,NMI
      J=MI(K)+6
      PROD(1,J)=FEED(L,J)/(1.0+(PPMI/PVAP(K))*(FTMI/GOLD-1.0))
      GNEW=GNEW+PROD(1,J)
3     CONTINUE
      IF(GNEW.EQ.0.0)GO TO 4
      IF(ABS((GNEW-GOLD)/GNEW).LT.0.00005)GO TO 6
      GO TO 5
4     IF(ABS(GNEW-GOLD).LT.0.005)GO TO 6
5     IF(GNEW.GT.GOLD)GMIN=GOLD
      IF(GNEW.LT.GOLD)GMAX=GOLD
      GO TO 2
6     RETURN
      END


      SUBROUTINE VLEIM(PPIM)

      DIMENSION PVAP(2)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

      IF(NIM.GT.1)GO TO 1
      J=IM(1)+6
      TB=PHPR(J-6,19)/(PHPR(J-6,18)-ALOG(PPIM/133.32))-PHPR(J-6,20)
      IF(PROD(1,4).LT.TB)PROD(1,J)=0.0
      IF(PROD(1,4).EQ.TB.AND.LID.EQ.0)PROD(1,J)=0.0
      IF(PROD(1,4).EQ.TB.AND.LID.EQ.1)PROD(1,J)=FEED(L,J)
      IF(PROD(1,4).GT.TB)PROD(1,J)=FEED(L,J)
      RETURN
1     TMIN=PROD(1,4)
      TMAX=PROD(1,4)
      KI=1
2     TB=(TMIN+TMAX)/2.0
      IF(KI.EQ.0.AND.(TMAX-TMIN).LT.0.1)GO TO 4
      PPIMC=0.0
      DO 3 K=1,NIM
      J=IM(K)+6
      PVAP(K)=133.32*EXP(PHPR(J-6,18)-PHPR(J-6,19)/
     *(TB+PHPR(J-6,20)))
3     PPIMC=PPIMC+PVAP(K)
      IF(PPIM.EQ.0.0)GO TO 31
      IF(ABS((PPIM-PPIMC)/PPIM).LT.0.00005)GO TO 4
      GO TO 32
31    IF(ABS(PPIM-PPIMC).LT.0.005)GO TO 4
32    IF(KI.EQ.1.AND.PPIMC.GT.PPIM)HV=1.0
      IF(KI.EQ.1.AND.PPIMC.LT.PPIM)HV=0.0
      IF(PPIMC.GT.PPIM)TMAX=TB
      IF(PPIMC.LT.PPIM)TMIN=TB  
      IF(PPIMC.LT.PPIM.AND.HV.EQ.0.0)TMAX=1.2*TB
      IF(PPIMC.GT.PPIM.AND.HV.EQ.1.0)TMIN=0.8*TB
      KI=0
      GO TO 2
4     IF(PROD(1,4).GT.TB)GO TO 6
      IF(PROD(1,4).EQ.TB.AND.LID.EQ.1)GO TO 6
      DO 5 K=1,NIM
      J=IM(K)+6
5     PROD(1,J)=0.0
      RETURN
6     J1=IM(1)+6
      J2=IM(2)+6
      IF(PVAP(1).LT.PVAP(2))GO TO 7
      PROD(1,J1)=FEED(L,J1)
      TB2=PHPR(J2-6,19)/(PHPR(J2-6,18)-ALOG(PPIM/133.32))-PHPR(J2-6,20)
      IF(PROD(1,4).GT.TB2)PROD(1,J2)=FEED(L,J2)
      IF(PROD(1,4).EQ.TB2.AND.LID.EQ.1)PROD(1,J2)=FEED(L,J2)
      IF(PROD(1,4).EQ.TB2.AND.LID.EQ.0)PROD(1,J2)=PVAP(2)*PROD(1,J1)/
     *PVAP(1)
      IF(PROD(1,4).LT.TB2)PROD(1,J2)=PVAP(2)*PROD(1,J1)/PVAP(1)
      RETURN
7     PROD(1,J2)=FEED(L,J2)
      TB1=PHPR(J1-6,19)/(PHPR(J1-6,18)-ALOG(PPIM/133.32))-PHPR(J1-6,20)
      IF(PROD(1,4).GT.TB1)PROD(1,J1)=FEED(L,J1)
      IF(PROD(1,4).EQ.TB1.AND.LID.EQ.1)PROD(1,J1)=FEED(L,J1)
      IF(PROD(1,4).EQ.TB1.AND.LID.EQ.0)PROD(1,J1)=PVAP(1)*PROD(1,J2)/
     *PVAP(2)
      IF(PROD(1,4).LT.TB1)PROD(1,J1)=PVAP(1)*PROD(1,J2)/PVAP(2)
      RETURN
      END


      SUBROUTINE VLEMM(PPMM)

      DIMENSION PVAP(14)

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

      FTMI=0.0
      DO 1 K=1,NMI
      J=MI(K)+6
      PVAP(K)=133.32*EXP(PHPR(J-6,18)-PHPR(J-6,19)/
     *(PROD(1,4)+PHPR(J-6,20)))
1     FTMI=FTMI+FEED(L,J) 
      IF(FTMI.EQ.0.0)GO TO 15
      J1=IM(1)+6
      IF(FEED(L,J1).EQ.0.0)GO TO 17
      TMIN=PROD(1,4)
      TMAX=PROD(1,4)
      KI=1
2     TB=(TMIN+TMAX)/2.0
      IF(KI.EQ.0.AND.(TMAX-TMIN).LT.0.1)GO TO 4
      PPMI=0.0
      PPMMC=0.0
      DO 3 K=1,NMI
      J=MI(K)+6
      PVMI=133.32*EXP(PHPR(J-6,18)-PHPR(J-6,19)/
     *(TB+PHPR(J-6,20)))
3     PPMI=PPMI+(FEED(L,J)/FTMI)*PVMI
      J1=IM(1)+6
      PPIM=133.32*EXP(PHPR(J1-6,18)-PHPR(J1-6,19)/
     *(TB+PHPR(J1-6,20)))
      PPMMC=PPMI+PPIM
      IF(PPMM.EQ.0.0)GO TO 31
      IF(ABS((PPMM-PPMMC)/PPMM).LT.0.00005)GO TO 4
      GO TO 32
31    IF(ABS(PPMM-PPMMC).LT.0.005)GO TO 4
32    IF(KI.EQ.1.AND.PPMMC.GT.PPMM)HV=1.0
      IF(KI.EQ.1.AND.PPMMC.LT.PPMM)HV=0.0
      IF(PPMMC.GT.PPMM)TMAX=TB
      IF(PPMMC.LT.PPMM)TMIN=TB  
      IF(PPMMC.LT.PPMM.AND.HV.EQ.0.0)TMAX=1.2*TB
      IF(PPMMC.GT.PPMM.AND.HV.EQ.1.0)TMIN=0.8*TB
      KI=0
      GO TO 2
4     IF(PROD(1,4).GT.TB)GO TO 6
      IF(PROD(1,4).EQ.TB.AND.LID.EQ.1)GO TO 6
      DO 5 K=1,NMI
      J=MI(K)+6
5     PROD(1,J)=0.0
      J1=IM(1)+6
      PROD(1,J1)=0.0
      RETURN
6     J1=IM(1)+6
      PROD(1,J1)=FEED(L,J1)
      DO 7 K=1,NMI
      J=MI(K)+6
7     DF=DF+(FEED(L,J)/FTMI)/(PVAP(K)/PPMI)
      IF(DF.LT.1.0)GO TO 8
      IF(DF.EQ.1.0.AND.LID.EQ.1)GO TO 8
      IF(DF.GT.1.0)GO TO 10
      IF(DF.EQ.1.0.AND.LID.EQ.0)GO TO 10
8     DO 9 K=1,NMI
      J=MI(K)+6
9     PROD(1,J)=FEED(L,J)
      RETURN
10    GMAX=FTMI
      GMIN=0.0
11    GOLD=(GMAX+GMIN)/2.0 
      IF((GMAX-GMIN).LT.0.01)GO TO 18
      GNEW=0.0
      DO 12 K=1,NMI
      J=MI(K)+6
      PROD(1,J)=FEED(L,J)/(1.0+(PPMI/PVAP(K))*(FTMI/GOLD-1.0))
      GNEW=GNEW+PROD(1,J)
12    CONTINUE
      IF(GNEW.EQ.0.0)GO TO 13
      IF(ABS((GNEW-GOLD)/GNEW).LT.0.00005)GO TO 18
      GO TO 14
13    IF(ABS(GNEW-GOLD).LT.0.005)GO TO 18
14    IF(GNEW.GT.GOLD)GMIN=GOLD
      IF(GNEW.LT.GOLD)GMAX=GOLD
      GO TO 11
15    DO 16 K=1,NMI
      J=MI(K)+6
16    PROD(1,J)=0.0
      CALL VLEIM(PPMM)
      RETURN
17    PROD(1,J1)=0.0
      CALL VLEMI(PPMM)
18    RETURN
      END


      SUBROUTINE UNIT01

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      PROD(1,1)=EQPM(NR,1)
      PROD(1,2)=EQPM(NR,4)
      PROD(1,3)=EQPM(NR,10)
      PROD(1,5)=FEED(1,5)
      DO 1 J=6,NL
      PROD(1,J)=0.0
      DO 1 I=1,NI
1     PROD(1,J)=PROD(1,J)+FEED(I,J)
      DO 2 I=1,NI
2     IF(FEED(I,5).LT.PROD(1,5))PROD(1,5)=FEED(I,5)
      IF(EQPM(NR,11).EQ.2.0)GO TO 7
      TMIN=FEED(1,4)
      TMAX=FEED(1,4)
      DO 3 I=1,NI
      IF(FEED(I,4).EQ.0.0)GO TO 6
      IF(FEED(I,4).NE.298.0.AND.FEED(I,6).EQ.0.0)GO TO 6
      IF(FEED(I,4).LT.TMIN)TMIN=FEED(I,4)
3     IF(FEED(I,4).GT.TMAX)TMAX=FEED(I,4)
4     ENTH=0.0
      PROD(1,4)=(TMIN+TMAX)/2.0
      IF((TMAX-TMIN).LT.0.1)GO TO 9
      DO 5 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
5     ENTH=ENTH+ADDENTH
      IF(PROD(1,6).EQ.0.0)GO TO 51
      IF(ABS((ENTH-PROD(1,6))/PROD(1,6)).LT.0.00005)GO TO 9
      GO TO 52
51    IF(ABS(ENTH-PROD(1,6)).LT.500.0)GO TO 9
52    IF(ENTH.GT.PROD(1,6))TMAX=PROD(1,4)
      IF(ENTH.LT.PROD(1,6))TMIN=PROD(1,4)
      GO TO 4
6     PROD(1,4)=0.0
      PROD(1,6)=0.0
      GO TO 9
7     PROD(1,4)=EQPM(NR,12)
      PROD(1,6)=0.0
      IF(EQPM(NR,12).EQ.0.0)GO TO 9
      DO 8 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
8     PROD(1,6)=PROD(1,6)+ADDENTH
9     RETURN
      END


      SUBROUTINE UNIT02

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      PROD(1,1)=EQPM(NR,1)
      PROD(1,2)=EQPM(NR,4)
      PROD(1,3)=FEED(1,3)
      PROD(1,4)=FEED(1,4)
      PROD(1,5)=1000.0*EQPM(NR,10)
      PROD(1,6)=FEED(1,6)
      DO 1 J=7,NL
1     PROD(1,J)=FEED(1,J)
      RETURN
      END


      SUBROUTINE UNIT03

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      PROD(I,3)=FEED(1,3)
      PROD(I,4)=FEED(1,4)
      PROD(I,5)=EQPM(1,5)
      DO 1 J=6,NL
1     PROD(I,J)=FEED(1,J)*EQPM(NR,I+9)
      RETURN
      END


      SUBROUTINE UNIT04

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      PROD(I,3)=EQPM(NR,9+I+NO*(NL-6))
      PROD(I,4)=FEED(1,4)
      PROD(I,5)=FEED(1,5)
      PROD(I,6)=0.0
      DO 1 J=7,NL
1     PROD(I,J)=FEED(1,J)*EQPM(NR,J+3+(NL-6)*(I-1))
      IF(FEED(1,4).EQ.0.0)GO TO 3
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 3
      DO 2 I=1,NO
      DO 2 J=7,NL
      CALL CALCENTH(ADDENTH,I,J)
2     PROD(I,6)=PROD(I,6)+ADDENTH
3     RETURN
      END


      SUBROUTINE UNIT05

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      PROD(I,3)=EQPM(NR,6+I+NL)
      PROD(I,4)=FEED(1,4)
      PROD(I,5)=FEED(1,5)
1     PROD(I,6)=0.0
      TOTMOL=0.0
      DO 2 J=7,NL
2     TOTMOL=TOTMOL+FEED(1,J)
      K=EQPM(NR,5+NL)+6.0
      IF(TOTMOL.EQ.0.0)P=0.0
      IF(TOTMOL.NE.0.0)P=TOTMOL*((FEED(1,K)/TOTMOL)-EQPM(NR,4+NL))/
     *                   (EQPM(NR,3+K)-EQPM(NR,4+NL))
      DO 3 J=7,NL
      PROD(1,J)=P*EQPM(NR,J+3)
3     PROD(2,J)=FEED(1,J)-PROD(1,J)
      IF(FEED(1,4).EQ.0.0)GO TO 5
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 5
      DO 4 I=1,NO
      DO 4 J=7,NL
      CALL CALCENTH(ADDENTH,I,J)
4     PROD(I,6)=PROD(I,6)+ADDENTH
5     RETURN
      END


      SUBROUTINE UNIT06

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      PROD(I,3)=FEED(1,3)
      PROD(I,4)=FEED(1,4)
1     PROD(I,5)=FEED(1,5)
      TOTMOL=0.0
      DO 2 J=7,NL
2     TOTMOL=TOTMOL+FEED(1,J)
      IF(EQPM(NR,11).EQ.1.0.AND.TOTMOL.NE.0.0)FACTOR=EQPM(NR,10)/TOTMOL
      IF(EQPM(NR,11).EQ.1.0.AND.TOTMOL.EQ.0.0)FACTOR=0.0
      IF(EQPM(NR,11).NE.1.0)FACTOR=1.0
      DO 3 J=6,NL
      PROD(1,J)=FACTOR*FEED(1,J)
3     PROD(2,J)=FEED(1,J)-PROD(1,J)
      IF(EQPM(NR,11).EQ.1.0)GO TO 4
      N=EQPM(NR,12)+6.0
      IF(EQPM(NR,11).EQ.2.0)PROD(1,N)=EQPM(NR,10)
      IF(EQPM(NR,11).EQ.3.0)PROD(1,N)=((TOTMOL-PROD(1,N))*EQPM(NR,10))
     */(1.0-EQPM(NR,10))
      PROD(2,N)=FEED(1,N)-PROD(1,N)
      IF(FEED(1,4).EQ.0.0)GO TO 4
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 4
      CALL CALCENTH(ADDENTH,2,N)
      PROD(2,6)=ADDENTH
      PROD(1,6)=FEED(1,6)-PROD(2,6)
4     RETURN
      END


      SUBROUTINE UNIT07

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of at least one input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Insufficient data for enthalpy calculation'
     */1X,'of output streams from unit No:',I3)

      DO 1 I=1,NO
      IF(FEED(1,1).EQ.EQPM(NR,10))L=I
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.1)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.2)L=1
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      DO 1 J=3,NL
1     PROD(I,J)=FEED(L,J)
      IF(NI.EQ.1)GO TO 6
      IF(FEED(1,4).EQ.0.0.OR.FEED(2,4).EQ.0.0)GO TO 5
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 5
      IF(FEED(2,4).NE.298.0.AND.FEED(2,6).EQ.0.0)GO TO 5
      PROD(1,4)=EQPM(NR,11)
      PROD(1,6)=0.0
      DO 2 J=7,NL
      IF(PROD(1,J).EQ.0.0)GO TO 40
      IF(FEED(1,4).LT.PHPR(J-6,2))GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.1.0)GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).GT.PHPR(J-6,2).AND.FEED(1,4).LT.PHPR(J-6,3))GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.3.0)GO TO 30
      IF(FEED(1,4).GT.PHPR(J-6,3))GO TO 30
      WRITE(3,200)NR
      CALL PROGSTOP
10    CALL ENTHLIQ(ADDENTH,1,J)
      GO TO 2
20    CALL ENTHSOL(ADDENTH,1,J)
      GO TO 2
30    CALL ENTHGAS(ADDENTH,1,J)
      GO TO 2
40    ADDENTH=0.0
2     PROD(1,6)=PROD(1,6)+ADDENTH
      PROD(2,6)=FEED(1,6)+FEED(2,6)-PROD(1,6)
      TMIN=AMIN1(FEED(1,4),FEED(2,4))
      TMAX=AMAX1(FEED(1,4),FEED(2,4))
3     ENTH=0.0
      PROD(2,4)=(TMIN+TMAX)/2.0
      IF((TMAX-TMIN).LT.0.1)GO TO 6
      DO 4 J=7,NL
      IF(PROD(2,J).EQ.0.0)GO TO 39
      IF(FEED(2,4).LT.PHPR(J-6,2))GO TO 21
      IF(FEED(2,4).EQ.PHPR(J-6,2).AND.PROD(2,3).EQ.1.0)GO TO 21
      IF(FEED(2,4).EQ.PHPR(J-6,2).AND.PROD(2,3).EQ.2.0)GO TO 11
      IF(FEED(2,4).GT.PHPR(J-6,2).AND.FEED(2,4).LT.PHPR(J-6,3))GO TO 11
      IF(FEED(2,4).EQ.PHPR(J-6,3).AND.PROD(2,3).EQ.2.0)GO TO 11
      IF(FEED(2,4).EQ.PHPR(J-6,3).AND.PROD(2,3).EQ.3.0)GO TO 31
      IF(FEED(2,4).GT.PHPR(J-6,3))GO TO 31
      WRITE(3,200)NR
      CALL PROGSTOP
11    CALL ENTHLIQ(ADDENTH,2,J)
      GO TO 4
21    CALL ENTHSOL(ADDENTH,2,J)
      GO TO 4
31    CALL ENTHGAS(ADDENTH,2,J)
      GO TO 4
39    ADDENTH=0.0
4     ENTH=ENTH+ADDENTH
      IF(PROD(2,6).EQ.0.0)GO TO 41
      IF(ABS((ENTH-PROD(2,6))/PROD(2,6)).LT.0.00005)GO TO 6
      GO TO 42
41    IF(ABS(ENTH-PROD(2,6)).LT.500.0)GO TO 6
42    IF(ENTH.GT.PROD(2,6))TMAX=PROD(2,4)
      IF(ENTH.LT.PROD(2,6))TMIN=PROD(2,4)
      GO TO 3
5     WRITE(3,100)NR
      CALL PROGSTOP
6     RETURN
      END


      SUBROUTINE UNIT08

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Insufficient data for enthalpy calculation'
     */1X,'of output streams from unit No:',I3)

      IF(FEED(1,4).EQ.0.0)GO TO 3
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 3
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
1     PROD(I,4)=EQPM(NR,I+9)
      N=EQPM(NR,13)+6.0
      PROD(1,3)=FEED(1,3)
      PROD(2,3)=2.0
      PROD(1,5)=FEED(1,5)
      PROD(2,5)=0.0
      PROD(1,6)=0.0
      DO 2 J=7,NL
      PROD(1,J)=FEED(1,J)
      PROD(2,J)=0.0
      IF(PROD(1,J).EQ.0.0)GO TO 40
      IF(FEED(1,4).LT.PHPR(J-6,2))GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.1.0)GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).GT.PHPR(J-6,2).AND.FEED(1,4).LT.PHPR(J-6,3))GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.3.0)GO TO 30
      IF(FEED(1,4).GT.PHPR(J-6,3))GO TO 30
      WRITE(3,200)NR
      CALL PROGSTOP
10    CALL ENTHLIQ(ADDENTH,1,J)
      GO TO 2
20    CALL ENTHSOL(ADDENTH,1,J)
      GO TO 2
30    CALL ENTHGAS(ADDENTH,1,J)
      GO TO 2
40    ADDENTH=0.0
2     PROD(1,6)=PROD(1,6)+ADDENTH
      PROD(2,N)=(FEED(1,6)-PROD(1,6))/
     *          (PHPR(N-6,8)*(PROD(2,4)-EQPM(NR,12))+
     *          (PHPR(N-6,9)*(PROD(2,4)**2-EQPM(NR,12)**2)/2.0))
      CALL ENTHLIQ(ADDENTH,2,N)
      PROD(2,6)=ADDENTH
      GO TO 4
3     WRITE(3,100)NR
      CALL PROGSTOP
4     RETURN
      END


      SUBROUTINE UNIT09

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

100   FORMAT(/1X,'Temperature/Enthalpy of at least one input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Temperature of vaporization/condensation'
     */1X,'of unit No:',I3,' is not specified')
300   FORMAT(/1X,'Insufficient data for enthalpy calculation'
     */1X,'of output streams from unit No:',I3)

      DO 2 I=1,NO
      IF(FEED(1,1).EQ.EQPM(NR,10).AND.I.EQ.1)L=1
      IF(FEED(1,1).EQ.EQPM(NR,10).AND.I.EQ.2)L=1
      IF(FEED(1,1).EQ.EQPM(NR,10).AND.I.EQ.3)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.1)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.2)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.3)L=1
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      IF(I.EQ.1.AND.EQPM(NR,13).EQ.1)GO TO 2
      IF(I.EQ.2.AND.EQPM(NR,13).EQ.2)GO TO 2
      DO 1 J=3,NL
1     PROD(I,J)=FEED(L,J)
2     CONTINUE
      IF(NI.EQ.1)GO TO 17
      IF(FEED(1,4).EQ.0.0.OR.FEED(2,4).EQ.0.0)GO TO 15
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 15
      IF(FEED(2,4).NE.298.0.AND.FEED(2,6).EQ.0.0)GO TO 15
      PROD(1,3)=3.0
      PROD(2,3)=2.0
      PROD(1,4)=EQPM(NR,11)
      PROD(2,4)=EQPM(NR,11)
      PROD(1,5)=1000.0*EQPM(NR,12)
      PROD(2,5)=1000.0*EQPM(NR,12)
      IF(FEED(1,1).EQ.EQPM(NR,10))L=1
      IF(FEED(1,1).NE.EQPM(NR,10))L=2
      NMI=EQPM(NR,14)
      NIM=EQPM(NR,15)
      NNC=EQPM(NR,16)
      IF(EQPM(NR,13).EQ.1)LID=1
      IF(EQPM(NR,13).EQ.2)LID=0
      DO 3 K=1,NMI
3     MI(K)=EQPM(NR,16+K)
      DO 4 K=1,NIM
4     IM(K)=EQPM(NR,16+NMI+K)
      DO 5 K=1,NNC
5     NC(K)=EQPM(NR,16+NMI+NIM+K)
      CALL CALCVLE
      IF((NMI+NIM).EQ.0)GO TO 7
      DO 6 K=1,NMI+NIM
      J=EQPM(NR,16+K)+6
      HEAT=PHPR(J-6,14)*((PHPR(J-6,16)-PROD(1,4))/
     *     (PHPR(J-6,16)-PHPR(J-6,3)))**0.38
      ENTL=(PHPR(J-6,8)*(PROD(1,4)-298.0)+
     *     (PHPR(J-6,9)*(PROD(1,4)**2-298.0**2)/2.0))
      PROD(1,6)=PROD(1,6)+PROD(1,J)*(HEAT+ENTL)
6     PROD(2,6)=PROD(2,6)+PROD(2,J)*ENTL
7     IF(NNC.EQ.0)GO TO 9
      DO 8 K=1,NNC
      J=EQPM(NR,16+NMI+NIM+K)+6
      CALL ENTHGAS(ADDENTH,1,J)
8     PROD(1,6)=PROD(1,6)+ADDENTH
9     DO 11 J=7,NL
      DO 10 K=1,NMI+NIM+NNC
      JK=EQPM(NR,16+K)+6
      IF(J.EQ.JK)GO TO 11
10    CONTINUE
      IF(PHPR(J-6,16).EQ.999999.AND.PHPR(J-6,2).EQ.999999)ADDENTH=
     *     PROD(2,J)*(PHPR(J-6,10)*(PROD(1,4)-298.0)+
     *     PHPR(J-6,11)*(PROD(1,4)**2-298.0**2)/2.0+
     *     PHPR(J-6,12)*(PROD(1,4)**3-298.0**3)/3.0)
      IF(PHPR(J-6,16).NE.999999.AND.PHPR(J-6,2).NE.999999)
     *     CALL CALCENTH(ADDENTH,2,J)      
      PROD(2,6)=PROD(2,6)+ADDENTH
11    CONTINUE 
      PROD(3,6)=FEED(1,6)+FEED(2,6)-PROD(1,6)-PROD(2,6)
      TMIN=AMIN1(FEED(1,4),FEED(2,4))
      TMAX=AMAX1(FEED(1,4),FEED(2,4))
      IF(L.EQ.1)M=2
      IF(L.EQ.2)M=1
12    ENTH=0.0
      PROD(3,4)=(TMIN+TMAX)/2.0
      IF((TMAX-TMIN).LT.0.1)GO TO 17
      DO 14 J=7,NL
      IF(PROD(3,J).EQ.0.0)GO TO 139
      IF(FEED(M,4).LT.PHPR(J-6,2))GO TO 132
      IF(FEED(M,4).EQ.PHPR(J-6,2).AND.PROD(3,3).EQ.1.0)GO TO 132
      IF(FEED(M,4).EQ.PHPR(J-6,2).AND.PROD(3,3).EQ.2.0)GO TO 131
      IF(FEED(M,4).GT.PHPR(J-6,2).AND.FEED(3,4).LT.PHPR(J-6,3))GO TO 131
      IF(FEED(M,4).EQ.PHPR(J-6,3).AND.PROD(3,3).EQ.2.0)GO TO 131
      IF(FEED(M,4).EQ.PHPR(J-6,3).AND.PROD(3,3).EQ.3.0)GO TO 133
      IF(FEED(M,4).GT.PHPR(J-6,3))GO TO 133
      WRITE(3,300)NR
      CALL PROGSTOP
131   CALL ENTHLIQ(ADDENTH,3,J)
      GO TO 14
132   CALL ENTHSOL(ADDENTH,3,J)
      GO TO 14
133   CALL ENTHGAS(ADDENTH,3,J)
      GO TO 14
139   ADDENTH=0.0
14    ENTH=ENTH+ADDENTH
      IF(PROD(3,6).EQ.0.0)GO TO 141
      IF(ABS((ENTH-PROD(3,6))/PROD(3,6)).LT.0.00005)GO TO 17
      GO TO 142
141   IF(ABS(ENTH-PROD(3,6)).LT.500.0)GO TO 17
142   IF(ENTH.GT.PROD(3,6))TMAX=PROD(3,4)
      IF(ENTH.LT.PROD(3,6))TMIN=PROD(3,4)
      GO TO 12
15    WRITE(3,100)NR
      CALL PROGSTOP
16    WRITE(3,200)NR
      CALL PROGSTOP
17    RETURN
      END


      SUBROUTINE UNIT10

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Insufficient data for enthalpy calculation'
     */1X,'of output streams from unit No:',I3)

      IF(FEED(1,4).EQ.0.0)GO TO 3
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 3
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,13)+6.0
      PROD(1,3)=FEED(1,3)
      PROD(1,4)=EQPM(NR,10)
      PROD(1,5)=FEED(1,5)
      PROD(1,6)=0.0
      IF(EQPM(NR,5).EQ.0.04)PROD(2,3)=2.0
      IF(EQPM(NR,5).EQ.0.03)PROD(2,3)=3.0
      PROD(2,4)=EQPM(NR,11)
      PROD(2,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,11)+PHPR(N-6,20)))
      DO 2 J=7,NL
      PROD(1,J)=FEED(1,J)
      PROD(2,J)=0.0
      IF(PROD(1,J).EQ.0.0)GO TO 40
      IF(FEED(1,4).LT.PHPR(J-6,2))GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.1.0)GO TO 20
      IF(FEED(1,4).EQ.PHPR(J-6,2).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).GT.PHPR(J-6,2).AND.FEED(1,4).LT.PHPR(J-6,3))GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.2.0)GO TO 10
      IF(FEED(1,4).EQ.PHPR(J-6,3).AND.PROD(1,3).EQ.3.0)GO TO 30
      IF(FEED(1,4).GT.PHPR(J-6,3))GO TO 30
      WRITE(3,200)NR
      CALL PROGSTOP
10    CALL ENTHLIQ(ADDENTH,1,J)
      GO TO 2
20    CALL ENTHSOL(ADDENTH,1,J)
      GO TO 2
30    CALL ENTHGAS(ADDENTH,1,J)
      GO TO 2
40    ADDENTH=0.0
2     PROD(1,6)=PROD(1,6)+ADDENTH
      IF(EQPM(NR,5).EQ.0.04)WENTH=0.0
      IF(EQPM(NR,5).EQ.0.03)WENTH=PHPR(N-6,8)*(EQPM(NR,11)-EQPM(NR,12))+
     *      PHPR(N-6,9)*(EQPM(NR,11)**2-EQPM(NR,12)**2)/2.0
      VENTH=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,11))/
     *      (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      PROD(2,N)=(ABS(FEED(1,6)-PROD(1,6)))/(WENTH+VENTH)
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-PROD(2,4))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      ENTL=(PHPR(N-6,8)*(PROD(2,4)-298.0)+
     *     (PHPR(N-6,9)*(PROD(2,4)**2-298.0**2)/2.0))
      IF(EQPM(NR,5).EQ.0.03)PROD(2,6)=PROD(2,N)*(HEAT+ENTL)
      IF(EQPM(NR,5).EQ.0.04)PROD(2,6)=PROD(2,N)*ENTL
      GO TO 4
3     WRITE(3,100)NR
      CALL PROGSTOP
4     RETURN
      END


      SUBROUTINE UNIT11

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')

      IF(FEED(1,4).EQ.0.0)GO TO 12
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 12
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,13)+6.0
      PROD(1,3)=3.0
      PROD(2,3)=2.0
      PROD(3,3)=2.0
      PROD(1,4)=EQPM(NR,10)
      PROD(2,4)=EQPM(NR,10)
      PROD(3,4)=EQPM(NR,12)
      PROD(1,5)=1000.0*EQPM(NR,11)
      PROD(2,5)=1000.0*EQPM(NR,11)
      PROD(3,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,12)+PHPR(N-6,20)))
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      DO 2 J=7,NL
2     PROD(3,J)=0.0
      NMI=EQPM(NR,14)
      NIM=EQPM(NR,15)
      NNC=EQPM(NR,16)
      LID=1
      L=1
      DO 3 K=1,NMI
3     MI(K)=EQPM(NR,16+K)
      DO 4 K=1,NIM
4     IM(K)=EQPM(NR,16+NMI+K)
      DO 5 K=1,NNC
5     NC(K)=EQPM(NR,16+NMI+NIM+K)
      CALL CALCVLE
      IF((NMI+NIM).EQ.0)GO TO 7
      DO 6 K=1,NMI+NIM
      J=EQPM(NR,16+K)+6
      HEAT=PHPR(J-6,14)*((PHPR(J-6,16)-PROD(1,4))/
     *     (PHPR(J-6,16)-PHPR(J-6,3)))**0.38
      ENTL=(PHPR(J-6,8)*(PROD(1,4)-298.0)+
     *     (PHPR(J-6,9)*(PROD(1,4)**2-298.0**2)/2.0))
      PROD(1,6)=PROD(1,6)+PROD(1,J)*(HEAT+ENTL)
6     PROD(2,6)=PROD(2,6)+PROD(2,J)*ENTL
7     IF(NNC.EQ.0)GO TO 9
      DO 8 K=1,NNC
      J=EQPM(NR,16+NMI+NIM+K)+6
      CALL ENTHGAS(ADDENTH,1,J)
8     PROD(1,6)=PROD(1,6)+ADDENTH
9     DO 11 J=7,NL
      DO 10 K=1,NMI+NIM+NNC
      JK=EQPM(NR,16+K)+6
      IF(J.EQ.JK)GO TO 11
10    CONTINUE
      IF(PHPR(J-6,16).EQ.999999.AND.PHPR(J-6,2).EQ.999999)ADDENTH=
     *     PROD(2,J)*(PHPR(J-6,10)*(PROD(1,4)-298.0)+
     *     PHPR(J-6,11)*(PROD(1,4)**2-298.0**2)/2.0+
     *     PHPR(J-6,12)*(PROD(1,4)**3-298.0**3)/3.0)
      IF(PHPR(J-6,16).NE.999999.AND.PHPR(J-6,2).NE.999999)
     *     CALL CALCENTH(ADDENTH,2,J)      
      PROD(2,6)=PROD(2,6)+ADDENTH
11    CONTINUE    
      VENTH=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,12))/
     *      (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      PROD(3,N)=(PROD(1,6)+PROD(2,6)-FEED(1,6))/VENTH
      PROD(3,6)=PROD(3,N)*(PHPR(N-6,8)*(PROD(3,4)-298.0)+
     *      PHPR(N-6,9)*(PROD(3,4)**2-298.0**2)/2.0)
      GO TO 13
12    WRITE(3,100)NR
      CALL PROGSTOP
13    RETURN
      END


      SUBROUTINE UNIT12

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')

      IF(FEED(1,4).EQ.0.0)GO TO 12
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 12
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,14)+6.0
      PROD(1,3)=3.0
      PROD(2,3)=2.0
      PROD(3,3)=2.0
      PROD(1,4)=EQPM(NR,10)
      PROD(2,4)=EQPM(NR,10)
      PROD(3,4)=EQPM(NR,12)
      PROD(1,5)=1000.0*EQPM(NR,11)
      PROD(2,5)=1000.0*EQPM(NR,11)
      PROD(3,5)=0.0
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      DO 2 J=7,NL
2     PROD(3,J)=0.0
      NMI=EQPM(NR,15)
      NIM=EQPM(NR,16)
      NNC=EQPM(NR,17)
      LID=0
      L=1
      DO 3 K=1,NMI
3     MI(K)=EQPM(NR,17+K)
      DO 4 K=1,NIM
4     IM(K)=EQPM(NR,17+NMI+K)
      DO 5 K=1,NNC
5     NC(K)=EQPM(NR,17+NMI+NIM+K)
      CALL CALCVLE
      IF((NMI+NIM).EQ.0)GO TO 7
      DO 6 K=1,NMI+NIM
      J=EQPM(NR,17+K)+6
      HEAT=PHPR(J-6,14)*((PHPR(J-6,16)-PROD(1,4))/
     *     (PHPR(J-6,16)-PHPR(J-6,3)))**0.38
      ENTL=(PHPR(J-6,8)*(PROD(1,4)-298.0)+
     *     (PHPR(J-6,9)*(PROD(1,4)**2-298.0**2)/2.0))
      PROD(1,6)=PROD(1,6)+PROD(1,J)*(HEAT+ENTL)
6     PROD(2,6)=PROD(2,6)+PROD(2,J)*ENTL
7     IF(NNC.EQ.0)GO TO 9
      DO 8 K=1,NNC
      J=EQPM(NR,17+NMI+NIM+K)+6
      CALL ENTHGAS(ADDENTH,1,J)
8     PROD(1,6)=PROD(1,6)+ADDENTH
9     DO 11 J=7,NL
      DO 10 K=1,NMI+NIM+NNC
      JK=EQPM(NR,17+K)+6
      IF(J.EQ.JK)GO TO 11
10    CONTINUE
      IF(PHPR(J-6,16).EQ.999999.AND.PHPR(J-6,2).EQ.999999)ADDENTH=
     *     PROD(2,J)*(PHPR(J-6,10)*(PROD(1,4)-298.0)+
     *     PHPR(J-6,11)*(PROD(1,4)**2-298.0**2)/2.0+
     *     PHPR(J-6,12)*(PROD(1,4)**3-298.0**3)/3.0)
      IF(PHPR(J-6,16).NE.999999.AND.PHPR(J-6,2).NE.999999)
     *     CALL CALCENTH(ADDENTH,2,J)      
      PROD(2,6)=PROD(2,6)+ADDENTH
11    CONTINUE    
      WENTH=PHPR(N-6,8)*(EQPM(NR,12)-EQPM(NR,13))+
     *      PHPR(N-6,9)*(EQPM(NR,12)**2-EQPM(NR,13)**2)/2.0
      PROD(3,N)=(FEED(1,6)-PROD(1,6)-PROD(2,6))/WENTH
      PROD(3,6)=PROD(3,N)*(PHPR(N-6,8)*(PROD(3,4)-298.0)+
     *      PHPR(N-6,9)*(PROD(3,4)**2-298.0**2)/2.0)
      GO TO 13
12    WRITE(3,100)NR
      CALL PROGSTOP
13    RETURN
      END
                         

      SUBROUTINE UNIT13

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of at least one input stream'
     */1X,'to unit No:',I3,' is not specified')

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      IF(FEED(1,1).EQ.EQPM(NR,10))L=1
      IF(FEED(1,1).NE.EQPM(NR,10))L=2
      IF(L.EQ.1)K=2
      IF(L.EQ.2)K=1
      N=EQPM(NR,13)+6.0
      DO 2 J=3,NL
      PROD(1,J)=FEED(L,J)
      PROD(2,J)=0.0
2     PROD(3,J)=FEED(K,J)
      PROD(2,3)=3.0
      PROD(1,4)=EQPM(NR,11)
      PROD(2,4)=EQPM(NR,11)
      PROD(1,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,11)+PHPR(N-6,20)))
      PROD(2,5)=PROD(1,5)
      PROD(1,6)=0.0
      DO 21 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
21    PROD(1,6)=PROD(1,6)+ADDENTH
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,11))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      ENTH=PHPR(N-6,8)*(EQPM(NR,11)-298.0)+
     *     PHPR(N-6,9)*(EQPM(NR,11)**2-298.0**2)/2.0
      KV=1
      IF(FEED(L,4).LE.EQPM(NR,11))GO TO 22
      KV=0
      IF(FEED(L,4).EQ.0.0)GO TO 4
      IF(FEED(L,4).NE.298.0.AND.FEED(L,6).EQ.0.0)GO TO 4
      PROD(2,N)=(FEED(L,6)-PROD(1,6))/HEAT
22    IF(NI.EQ.1)GO TO 23
      IF(FEED(K,4).EQ.0.0)GO TO 4
      IF(FEED(K,4).NE.298.0.AND.FEED(K,6).EQ.0.0)GO TO 4
      PROD(3,3)=2.0
      PROD(3,4)=EQPM(NR,12)
      PROD(3,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,12)+PHPR(N-6,20)))
      PROD(3,6)=PROD(3,N)*(PHPR(N-6,8)*(PROD(3,4)-298.0)+
     *      PHPR(N-6,9)*(PROD(3,4)**2-298.0**2)/2.0)
      PROD(2,N)=(FEED(K,6)-PROD(3,6)+KV*(FEED(L,6)-PROD(1,6)))/HEAT+
     *          PROD(2,N)
23    PROD(1,N)=PROD(1,N)-PROD(2,N)
      PROD(1,6)=0.0
      DO 3 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
3     PROD(1,6)=PROD(1,6)+ADDENTH
      PROD(2,6)=PROD(2,N)*(ENTH+HEAT)
      GO TO 5
4     WRITE(3,100)NR
      CALL PROGSTOP
5     RETURN
      END
      

      SUBROUTINE UNIT14

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')

      IF(FEED(1,4).EQ.0.0)GO TO 4
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 4
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,13)+6.0
      M=EQPM(NR,14)+6.0
      PROD(1,3)=2.0
      PROD(2,3)=3.0
      PROD(3,3)=2.0
      PROD(1,4)=EQPM(NR,10)
      PROD(2,4)=EQPM(NR,10)
      PROD(3,4)=EQPM(NR,12)
      PROD(1,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,10)+PHPR(N-6,20)))
      PROD(2,5)=PROD(1,5)
      PROD(3,5)=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,12)+PHPR(N-6,20)))
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      TOTMOL=0.0
      DO 2 J=7,NL
      PROD(1,J)=FEED(1,J)
      PROD(2,J)=0.0
      PROD(3,J)=0.0
2     TOTMOL=TOTMOL+FEED(1,J)
      PROD(2,N)=TOTMOL-PROD(1,M)/EQPM(NR,11)
      PROD(1,N)=FEED(1,N)-PROD(2,N)
      IF(EQPM(NR,16).EQ.0.0)PROD(2,N)=PROD(2,N)/(EQPM(NR,15)+1.0)
      EQPM(NR,16)=1.0
      ENTH=PHPR(N-6,8)*(EQPM(NR,10)-298.0)+
     *     PHPR(N-6,9)*(EQPM(NR,10)**2-298.0**2)/2.0
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,10))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      DO 3 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
3     PROD(1,6)=PROD(1,6)+ADDENTH
      PROD(2,6)=PROD(2,N)*(ENTH+HEAT)
      VENTH=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,12))/
     *      (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      PROD(3,N)=(PROD(1,6)+PROD(2,6)-FEED(1,6))/(VENTH)
      PROD(3,6)=PROD(3,N)*(PHPR(N-6,8)*(PROD(3,4)-298.0)+
     *      PHPR(N-6,9)*(PROD(3,4)**2-298.0**2)/2.0)
      GO TO 5
4     WRITE(3,100)NR
      CALL PROGSTOP
5     RETURN
      END


      SUBROUTINE UNIT15

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of at least one input stream'
     */1X,'to unit No:',I3,' is not specified')

      DO 1 I=1,NO
      IF(FEED(1,1).EQ.EQPM(NR,10))L=I
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.1)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.2)L=1
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      DO 1 J=3,NL
1     PROD(I,J)=FEED(L,J)
      N=EQPM(NR,13)+6.0
      IF(NI.EQ.1)GO TO 5
      IF(FEED(1,4).EQ.0.0.OR.FEED(2,4).EQ.0.0)GO TO 4
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 4
      IF(FEED(2,4).NE.298.0.AND.FEED(2,6).EQ.0.0)GO TO 4
      PROD(1,4)=EQPM(NR,11)
      PROD(2,4)=EQPM(NR,12)
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      DO 2 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
      PROD(1,6)=PROD(1,6)+ADDENTH
      CALL CALCENTH(ADDENTH,2,J)
2     PROD(2,6)=PROD(2,6)+ADDENTH
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,12))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      PROD(2,6)=PROD(2,6)+PROD(2,N)*HEAT
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,11))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      ENTH=PHPR(N-6,4)*(EQPM(NR,12)-EQPM(NR,11))+
     *     PHPR(N-6,5)*(EQPM(NR,12)**2-EQPM(NR,11)**2)/2.0+
     *     PHPR(N-6,6)*(EQPM(NR,12)**3-EQPM(NR,11)**3)/3.0+
     *     PHPR(N-6,7)*(EQPM(NR,12)**4-EQPM(NR,11)**4)/4.0
      WEVAP=(FEED(1,6)+FEED(2,6)-PROD(1,6)-PROD(2,6))/(HEAT+ENTH)
      PROD(2,N)=PROD(2,N)+WEVAP
      PROD(1,N)=PROD(1,N)-WEVAP
      PROD(1,6)=0.0
      DO 3 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
3     PROD(1,6)=PROD(1,6)+ADDENTH
      PROD(2,6)=FEED(1,6)+FEED(2,6)-PROD(1,6)
      GO TO 5
4     WRITE(3,100)NR
      CALL PROGSTOP
5     RETURN
      END


      SUBROUTINE UNIT16

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')

      IF(FEED(1,4).EQ.0.0)GO TO 5
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 5
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,15)+6.0
      M=EQPM(NR,16)+6.0
      K=EQPM(NR,17)+6.0
      PROD(1,3)=FEED(1,3)
      PROD(2,3)=3.0
      PROD(1,4)=EQPM(NR,11)
      PROD(2,4)=EQPM(NR,14)
      PROD(1,5)=FEED(1,5)
      PROD(2,5)=0.0
      TOTMOL=0.0
      DO 2 J=7,NL
      PROD(1,J)=FEED(1,J)
      PROD(2,J)=0.0
2     IF(J.NE.N)TOTMOL=TOTMOL+FEED(1,J)
      PROD(1,N)=EQPM(NR,10)*TOTMOL/(1.0-EQPM(NR,10))
      PROD(1,6)=0.0
      DO 3 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
3     PROD(1,6)=PROD(1,6)+ADDENTH
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,11))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      ENTHL=PHPR(N-6,8)*(EQPM(NR,11)-298.0)+
     *      PHPR(N-6,9)*(EQPM(NR,11)**2-298.0**2)/2.0
      ENTHG=PHPR(N-6,4)*(EQPM(NR,14)-EQPM(NR,11))+
     *      PHPR(N-6,5)*(EQPM(NR,14)**2-EQPM(NR,11)**2)/2.0+
     *      PHPR(N-6,6)*(EQPM(NR,14)**3-EQPM(NR,11)**3)/3.0+
     *      PHPR(N-6,7)*(EQPM(NR,14)**4-EQPM(NR,11)**4)/4.0
      WENTH=(FEED(1,N)-PROD(1,N))*(ENTHL+ENTHG+HEAT)
      HEATI=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,13))/
     *      (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      HEATO=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,14))/
     *      (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      DENTW=PHPR(N-6,8)*(EQPM(NR,14)-EQPM(NR,13))+
     *      PHPR(N-6,9)*(EQPM(NR,14)**2-EQPM(NR,13)**2)/2.0
      DENTO=PHPR(M-6,4)*(EQPM(NR,14)-EQPM(NR,13))+
     *      PHPR(M-6,5)*(EQPM(NR,14)**2-EQPM(NR,13)**2)/2.0+
     *      PHPR(M-6,6)*(EQPM(NR,14)**3-EQPM(NR,13)**3)/3.0+
     *      PHPR(M-6,7)*(EQPM(NR,14)**4-EQPM(NR,13)**4)/4.0
      DENTN=PHPR(K-6,4)*(EQPM(NR,14)-EQPM(NR,13))+
     *      PHPR(K-6,5)*(EQPM(NR,14)**2-EQPM(NR,13)**2)/2.0+
     *      PHPR(K-6,6)*(EQPM(NR,14)**3-EQPM(NR,13)**3)/3.0+
     *      PHPR(K-6,7)*(EQPM(NR,14)**4-EQPM(NR,13)**4)/4.0
      TOTMOL=(FEED(1,6)-PROD(1,6)-WENTH)/((DENTW+HEATO-HEATI)*
     *       EQPM(NR,12)+(1.0-EQPM(NR,12))*(0.212*DENTO+0.788*DENTN))
      PROD(2,N)=EQPM(NR,12)*TOTMOL+FEED(1,N)-PROD(1,N)
      PROD(2,M)=0.212*(1.0-EQPM(NR,12))*TOTMOL
      PROD(2,K)=0.788*(1.0-EQPM(NR,12))*TOTMOL
      PROD(2,6)=PROD(2,N)*HEATO
      DO 4 J=7,NL
      CALL CALCENTH(ADDENTH,2,J)
4     PROD(2,6)=PROD(2,6)+ADDENTH
      GO TO 6
5     WRITE(3,100)NR
      CALL PROGSTOP
6     RETURN
      END


      SUBROUTINE UNIT17

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of at least one input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Inaccurate data for temperature calculation'
     */1X,'of water output stream from unit No:',I3)

      DO 1 I=1,NO
      IF(FEED(1,1).EQ.EQPM(NR,10))L=I
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.1)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.2)L=1
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      DO 1 J=3,NL
1     PROD(I,J)=FEED(L,J)
      N=EQPM(NR,13)+6.0
      M=EQPM(NR,14)+6.0
      K=EQPM(NR,15)+6.0
      IF(NI.EQ.1)GO TO 4
      IF(FEED(1,1).EQ.EQPM(NR,10))L=1 
      IF(FEED(1,1).NE.EQPM(NR,10))L=2 
      IF(FEED(1,4).EQ.0.0.OR.FEED(2,4).EQ.0.0)GO TO 3
      IF(FEED(L,4).NE.298.0.AND.FEED(L,6).EQ.0.0)GO TO 3
      PROD(2,4)=EQPM(NR,12)
      PVAPO=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,12)+PHPR(N-6,20)))
      FACTOR=(18.015/(0.212*31.999+0.788*28.013))*
     *       ((0.212*PHPR(M-6,1)+0.788*PHPR(K-6,1))/PHPR(N-6,1))
      HUMDO=EQPM(NR,11)*(PVAPO/(101330.0-PVAPO))*FACTOR
      HEAT=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,12))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      PROD(2,N)=HUMDO*(PROD(2,M)+PROD(2,K))
      PROD(2,6)=PROD(2,N)*HEAT
      DO 2 J=7,NL
      CALL CALCENTH(ADDENTH,2,J)
2     PROD(2,6)=PROD(2,6)+ADDENTH 
      PROD(1,N)=FEED(1,N)+FEED(2,N)-PROD(2,N)
      PROD(1,6)=FEED(1,6)+FEED(2,6)-PROD(2,6)
      IF(PROD(1,N).LE.0.0)GO TO 4
      ENTWO=PROD(1,6)/PROD(1,N)
      ENTHC=75425.2*PHPR(N-6,1)/18.015
      PROD(1,4)=(ENTHC*298.0+ENTWO)/ENTHC
      GO TO 5
3     WRITE(3,100)NR
      CALL PROGSTOP
4     WRITE(3,200)NR
      CALL PROGSTOP
5     RETURN
      END


      SUBROUTINE UNIT18

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

100   FORMAT(/1X,'Temperature/Enthalpy of process input stream'
     */1X,'to unit No:',I3,' is not specified')

      IF(FEED(1,4).EQ.0.0)GO TO 4
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 4
      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
1     PROD(I,2)=EQPM(NR,I+3)
      N=EQPM(NR,15)+6.0  
      M=EQPM(NR,16)+6.0
      K=EQPM(NR,17)+6.0
      PROD(1,3)=2.0
      PROD(2,3)=3.0
      PROD(1,4)=EQPM(NR,10)
      PROD(2,4)=EQPM(NR,14)
      PROD(1,5)=FEED(1,5)
      PROD(2,5)=0.0
      DO 2 J=7,NL
      PROD(1,J)=FEED(1,J)
2     PROD(2,J)=0.0
      CALL CALCENTH(ADDENTH,1,N)
      PROD(1,6)=ADDENTH
      PVAPI=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,13)+PHPR(N-6,20)))
      PVAPO=133.32*EXP(PHPR(N-6,18)-PHPR(N-6,19)/
     *          (EQPM(NR,14)+PHPR(N-6,20)))
      FACTOR=(18.015/(0.212*31.999+0.788*28.013))*
     *       ((0.212*PHPR(M-6,1)+0.788*PHPR(K-6,1))/PHPR(N-6,1))
      HUMDI=EQPM(NR,11)*(PVAPI/(101330.0-PVAPI))*FACTOR
      HUMDO=EQPM(NR,12)*(PVAPO/(101330.0-PVAPO))*FACTOR
      HEATI=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,13))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      HEATO=PHPR(N-6,14)*((PHPR(N-6,16)-EQPM(NR,14))/
     *     (PHPR(N-6,16)-PHPR(N-6,3)))**0.38
      ENTWI=PHPR(N-6,8)*(EQPM(NR,13)-298.0)+
     *      PHPR(N-6,9)*(EQPM(NR,13)**2-298.0**2)/2.0
      ENTWO=PHPR(N-6,8)*(EQPM(NR,14)-298.0)+
     *      PHPR(N-6,9)*(EQPM(NR,14)**2-298.0**2)/2.0
      ENTWE=PHPR(N-6,8)*(EQPM(NR,10)-298.0)+
     *      PHPR(N-6,9)*(EQPM(NR,10)**2-298.0**2)/2.0
      DENTO=PHPR(M-6,4)*(EQPM(NR,14)-EQPM(NR,13))+
     *      PHPR(M-6,5)*(EQPM(NR,14)**2-EQPM(NR,13)**2)/2.0+
     *      PHPR(M-6,6)*(EQPM(NR,14)**3-EQPM(NR,13)**3)/3.0+
     *      PHPR(M-6,7)*(EQPM(NR,14)**4-EQPM(NR,13)**4)/4.0
      DENTN=PHPR(K-6,4)*(EQPM(NR,14)-EQPM(NR,13))+
     *      PHPR(K-6,5)*(EQPM(NR,14)**2-EQPM(NR,13)**2)/2.0+
     *      PHPR(K-6,6)*(EQPM(NR,14)**3-EQPM(NR,13)**3)/3.0+
     *      PHPR(K-6,7)*(EQPM(NR,14)**4-EQPM(NR,13)**4)/4.0
      TOTAIR=(FEED(1,6)-PROD(1,6))/(0.212*DENTO+0.788*DENTN+
     *      HUMDO*(ENTWO+HEATO-ENTWE)-HUMDI*(ENTWI+HEATI-ENTWE))
      PROD(2,N)=HUMDO*TOTAIR
      PROD(1,N)=FEED(1,N)+HUMDI*TOTAIR-PROD(2,N)
      PROD(2,M)=0.212*TOTAIR
      PROD(2,K)=0.788*TOTAIR
      CALL CALCENTH(ADDENTH,1,N)
      PROD(1,6)=ADDENTH
      PROD(2,6)=PROD(2,N)*HEATO
      DO 3 J=7,NL
      CALL CALCENTH(ADDENTH,2,J)
3     PROD(2,6)=PROD(2,6)+ADDENTH
      GO TO 5
4     WRITE(3,100)NR
      CALL PROGSTOP
5     RETURN
      END


      SUBROUTINE UNIT19

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      PROD(I,3)=2.0
      PROD(I,4)=FEED(1,4)
      PROD(I,5)=FEED(1,5)
1     PROD(I,6)=0.0
      NH=EQPM(NR,12)
      TOTFD=0.0
      TOTHF=0.0
      DO 2 J=7,NL
2     TOTFD=TOTFD+FEED(1,J)
      DO 3 I=1,NH
      K=EQPM(NR,12+I)+6.0
3     TOTHF=TOTHF+FEED(1,K)
      TOTLF=TOTFD-TOTHF
      TOTPL=(TOTLF-EQPM(NR,10)*TOTFD)/(1.0-EQPM(NR,10)-EQPM(NR,11))
      TOTPH=(TOTHF-EQPM(NR,11)*TOTFD)/(1.0-EQPM(NR,10)-EQPM(NR,11))  
      TOTHL=EQPM(NR,11)*TOTPL
      TOTLH=EQPM(NR,10)*TOTPH
      DO 7 J=7,NL
      DO 4 I=1,NH
      IF(J.EQ.(EQPM(NR,12+I)+6))GO TO 5
4     CONTINUE
      GO TO 6
5     PROD(1,J)=(TOTHL/TOTHF)*FEED(1,J)
      PROD(2,J)=FEED(1,J)-PROD(1,J)
      GO TO 7
6     PROD(2,J)=(TOTLH/TOTLF)*FEED(1,J)
      PROD(1,J)=FEED(1,J)-PROD(2,J)
7     CONTINUE
      IF(FEED(1,4).EQ.0.0)GO TO 9
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 9
      DO 8 I=1,NO
      DO 8 J=7,NL
      CALL CALCENTH(ADDENTH,I,J)
8     PROD(I,6)=PROD(I,6)+ADDENTH
9     RETURN
      END


      SUBROUTINE UNIT20

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      DO 1 I=1,NO
      IF(FEED(1,1).EQ.EQPM(NR,10))L=I
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.1)L=2
      IF(FEED(1,1).NE.EQPM(NR,10).AND.I.EQ.2)L=1
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      DO 1 J=3,NL
1     PROD(I,J)=FEED(L,J)
      IF(NI.EQ.1)GO TO 5
      DO 2 I=1,NO
      PROD(I,4)=EQPM(NR,11)
2     PROD(I,5)=1000.0*EQPM(NR,12)
      N=EQPM(NR,13)
      DO 3 J=7,NL
      IF(FEED(1,1).NE.EQPM(NR,10))L=N
      IF(FEED(1,1).EQ.EQPM(NR,10).AND.N.EQ.1)L=2
      IF(FEED(1,1).EQ.EQPM(NR,10).AND.N.EQ.2)L=1
      PROD(N,J)=EQPM(NR,J+7)*FEED(L,J)
      IF(L.EQ.1)K=2
      IF(L.EQ.2)K=1
      PROD(N,J)=PROD(N,J)+FEED(K,J)
      IF(N.EQ.1)M=2
      IF(N.EQ.2)M=1
3     PROD(M,J)=FEED(1,J)+FEED(2,J)-PROD(N,J)
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      IF(EQPM(NR,11).EQ.0.0)GO TO 5
      DO 4 I=1,NO
      DO 4 J=7,NL
      CALL CALCENTH(ADDENTH,I,J)
4     PROD(I,6)=PROD(I,6)+ADDENTH
5     RETURN
      END


      SUBROUTINE UNIT21

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL
      COMMON/GROUPD/MI(14),IM(2),NC(14),NMI,NIM,NNC,LID,L

100   FORMAT(/1X,'Temperature/Enthalpy of input stream'
     */1X,'to unit No:',I3,' is not specified')
200   FORMAT(/1X,'Temperatures of both output streams'
     */1X,'from unit No:',I3,' are not specified') 

      DO 1 I=1,NO
      PROD(I,1)=EQPM(NR,1)
      PROD(I,2)=EQPM(NR,I+3)
      IF(EQPM(NR,10).EQ.1.0.OR.EQPM(NR,10).EQ.2.0)PROD(I,4)=FEED(1,4)
      IF(EQPM(NR,10).EQ.3.0)PROD(I,4)=EQPM(NR,11)
      PROD(I,5)=1000.0*EQPM(NR,12)
1     PROD(I,6)=0.0
      IF(EQPM(NR,10).EQ.1.0.AND.FEED(1,4).EQ.0.0)GO TO 12
      IF(EQPM(NR,10).EQ.1.0.AND.FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)
     *GO TO 12
      IF(EQPM(NR,10).EQ.2.0.AND.FEED(1,4).EQ.0.0)GO TO 12
      IF(EQPM(NR,10).EQ.3.0.AND.EQPM(NR,11).EQ.0.0)GO TO 13
      PROD(1,3)=3.0
      PROD(2,3)=2.0
      NMI=EQPM(NR,14)
      NIM=EQPM(NR,15)
      NNC=EQPM(NR,16)
      IF(EQPM(NR,13).EQ.1)LID=1
      IF(EQPM(NR,13).EQ.2)LID=0
      L=1
      DO 3 K=1,NMI
3     MI(K)=EQPM(NR,16+K)
      DO 4 K=1,NIM
4     IM(K)=EQPM(NR,16+NMI+K)
      DO 5 K=1,NNC
5     NC(K)=EQPM(NR,16+NMI+NIM+K)
      KI=1
99    CALL CALCVLE
      IF((NMI+NIM).EQ.0)GO TO 7
      DO 6 K=1,NMI+NIM
      J=EQPM(NR,16+K)+6
      HEAT=PHPR(J-6,14)*((PHPR(J-6,16)-PROD(1,4))/
     *     (PHPR(J-6,16)-PHPR(J-6,3)))**0.38
      ENTL=(PHPR(J-6,8)*(PROD(1,4)-298.0)+
     *     (PHPR(J-6,9)*(PROD(1,4)**2-298.0**2)/2.0))
      PROD(1,6)=PROD(1,6)+PROD(1,J)*(HEAT+ENTL)
6     PROD(2,6)=PROD(2,6)+PROD(2,J)*ENTL
7     IF(NNC.EQ.0)GO TO 9
      DO 8 K=1,NNC
      J=EQPM(NR,16+NMI+NIM+K)+6
      CALL ENTHGAS(ADDENTH,1,J)
8     PROD(1,6)=PROD(1,6)+ADDENTH
9     DO 11 J=7,NL
      DO 10 K=1,NMI+NIM+NNC
      JK=EQPM(NR,16+K)+6
      IF(J.EQ.JK)GO TO 11
10    CONTINUE
      IF(PHPR(J-6,16).EQ.999999.AND.PHPR(J-6,2).EQ.999999)ADDENTH=
     *     PROD(2,J)*(PHPR(J-6,10)*(PROD(1,4)-298.0)+
     *     PHPR(J-6,11)*(PROD(1,4)**2-298.0**2)/2.0+
     *     PHPR(J-6,12)*(PROD(1,4)**3-298.0**3)/3.0)
      IF(PHPR(J-6,16).NE.999999.AND.PHPR(J-6,2).NE.999999)
     *     CALL CALCENTH(ADDENTH,2,J)      
      PROD(2,6)=PROD(2,6)+ADDENTH
11    CONTINUE    
      IF(EQPM(NR,10).EQ.2.0.OR.EQPM(NR,10).EQ.3.0)GO TO 14
      IF((PROD(1,6)+PROD(2,6)).EQ.0.0)GO TO 111
      IF(ABS((PROD(1,6)+PROD(2,6)-FEED(1,6))/(PROD(1,6)+PROD(2,6))).LT.
     *0.00005)GO TO 14
      GO TO 112
111   IF(ABS(PROD(1,6)+PROD(2,6)-FEED(1,6)).LT.500.0)GO TO 14
112   IF(KI.EQ.1.AND.(PROD(1,6)+PROD(2,6)).GT.FEED(1,6))HF=1.0
      IF(KI.EQ.1.AND.(PROD(1,6)+PROD(2,6)).LT.FEED(1,6))HF=0.0
      IF((PROD(1,6)+PROD(2,6)).GT.FEED(1,6))TMAX=PROD(1,4)
      IF((PROD(1,6)+PROD(2,6)).LT.FEED(1,6))TMIN=PROD(1,4)
      IF((PROD(1,6)+PROD(2,6)).LT.FEED(1,6).AND.HF.EQ.0.0)TMAX=1.2*TMAX
      IF((PROD(1,6)+PROD(2,6)).GT.FEED(1,6).AND.HF.EQ.1.0)TMIN=0.8*TMIN
      PROD(1,4)=(TMIN+TMAX)/2.0
      PROD(2,4)=(TMIN+TMAX)/2.0
      IF(KI.EQ.0.AND.(TMAX-TMIN).LT.0.1)GO TO 14
      KI=0
      PROD(1,6)=0.0
      PROD(2,6)=0.0
      GO TO 99
12    WRITE(3,100)NR
      CALL PROGSTOP
13    WRITE(3,200)NR
      CALL PROGSTOP
14    RETURN
      END


      SUBROUTINE UNIT22

      COMMON/GROUPC/EQPM(10,80),PHPR(14,21),FEED(9,20),PROD(9,20),NI,NO,
     *NR,NL

      PROD(1,1)=EQPM(NR,1)
      PROD(1,2)=EQPM(NR,4)
      PROD(1,3)=EQPM(NR,10)
      PROD(1,5)=FEED(1,5)
      K=EQPM(NR,14)+6.0
      DO 1 J=7,NL
1     PROD(1,J)=FEED(1,J)+FEED(1,K)*EQPM(NR,13)*EQPM(NR,J+8)
      IF(EQPM(NR,11).EQ.2.0.OR.EQPM(NR,11).EQ.3.0)GO TO 6
      IF(FEED(1,4).EQ.0.0)GO TO 5
      IF(FEED(1,4).NE.298.0.AND.FEED(1,6).EQ.0.0)GO TO 5
      HRCT=0.0
      DO 2 J=7,NL
2     HRCT=HRCT+(PROD(1,J)-FEED(1,J))*PHPR(J-6,15)
      PROD(1,6)=FEED(1,6)+HRCT
      TMIN=FEED(1,4)
      TMAX=FEED(1,4)
      IF(HRCT.GT.0.0)TMAX=1.2*TMAX
      IF(HRCT.LT.0.0)TMIN=0.8*TMIN
      KI=1
3     ENTH=0.0
      PROD(1,4)=(TMIN+TMAX)/2.0
      IF(KI.EQ.0.AND.(TMAX-TMIN).LT.0.1)GO TO 8
      DO 4 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)
4     ENTH=ENTH+ADDENTH
      IF(PROD(1,6).EQ.0.0)GO TO 41
      IF(ABS((ENTH-PROD(1,6))/PROD(1,6)).LT.0.00005)GO TO 8
      GO TO 42
41    IF(ABS(ENTH-PROD(1,6)).LT.500.0)GO TO 8
42    IF(ENTH.GT.PROD(1,6))TMAX=PROD(1,4)
      IF(ENTH.LT.PROD(1,6))TMIN=PROD(1,4)
      IF(ENTH.LT.PROD(1,6).AND.HRCT.GT.0.0)TMAX=1.2*TMAX
      IF(ENTH.GT.PROD(1,6).AND.HRCT.LT.0.0)TMIN=0.8*TMIN
      KI=0
      GO TO 3
5     PROD(1,4)=0.0
      PROD(1,6)=0.0
      GO TO 8
6     IF(EQPM(NR,11).EQ.2.0)PROD(1,4)=FEED(1,4) 
      IF(EQPM(NR,11).EQ.3.0)PROD(1,4)=EQPM(NR,12)
      PROD(1,6)=0.0
      IF(PROD(1,4).EQ.0.0)GO TO 8
      DO 7 J=7,NL
      CALL CALCENTH(ADDENTH,1,J)    
7     PROD(1,6)=PROD(1,6)+ADDENTH      
8     RETURN
      END
